//////////////////////////////////////////////////////////////////////
// Acknex header file for lite-C
//////////////////////////////////////////////////////////////////////
#ifndef acknex_h	// don't include twice
#define acknex_h

#include <litec.h>
#include <compat.h>

typedef fixed var;
typedef fixed function;
typedef void action;	// parsed by WED for entity functions

#include <atypes.h>

/////////////////////////////////////////////////////////////////////
#define EXT
#define F(f) f

#define afuncs_dll_h	// exclude DLL functions
#include <afuncs.h>

//overloaded functions
var abs(var);
var acos(var);
var asin(var);
var atan(var);
var cos(var);
var sin(var);
var tan(var);
STRING* txt_str(TEXT*);

// special functions not listed in afuncs.h
var wait(var);
STRING* inkey(STRING*);

// convenience definitions
#define set(obj,flag) obj.flags |= (flag)
#define reset(obj,flag) obj.flags &= ~(flag)
#define toggle(obj,flag) obj.flags ^= (flag)
#define is(obj,flag) (obj.flags & (flag))
#define wait_for(function) while (proc_status(function)) wait(1)
#define zero(ptr) memset((void*)&ptr,0,sizeof(ptr))
#define vec_zero(vec) ((var*)&(vec))[0] = 0; ((var*)&(vec))[1] = 0; ((var*)&(vec))[2] = 0
#define set_zero(ptr,len) memset((void*)&ptr,0,len)

/////////////////////////////////////////////////////////////////////
#define ENGINE_VAR		extern var
#define ENGINE_VECTOR	extern VECTOR
#define ENGINE_COLOR	extern COLOR
#define ENGINE_ANGLE	extern ANGLE
#define ENGINE_EVENT	extern EVENT
#define ENGINE_ENTITY	extern ENTITY*
#define ENGINE_STRING	extern STRING*
#define ENGINE_BMAP		extern BMAP*
#define ENGINE_VIEW		extern VIEW*
#define ENGINE_MATERIAL	extern MATERIAL*
#define ENGINE_TEXTURE	extern TEXTURE*
#define ENGINE_			extern

#include <avars.h>

//convenience definitions
ENGINE_ENTITY my;
ENGINE_ENTITY your;

VECTOR* nullvector = { x=0; y=0; z=0; }
#endif